
package com.uelongTencentCaptcha;

import com.facebook.react.bridge.ReactApplicationContext;
import com.facebook.react.bridge.ReactContextBaseJavaModule;
import com.facebook.react.bridge.ReactMethod;
import com.facebook.react.bridge.Callback;
import com.facebook.react.bridge.Promise;
import com.facebook.react.bridge.WritableMap;

import com.tencent.captchasdk.TCaptchaDialog;
import com.tencent.captchasdk.TCaptchaVerifyListener;

import org.json.JSONObject;

//import static com.facebook.react.bridge.UiThreadUtil.runOnUiThread;

public class RNUelongTencentCaptchaModule extends ReactContextBaseJavaModule {

  private final ReactApplicationContext reactContext;
  private TCaptchaDialog dialog;
  private Promise verifyPromise;
  private Promise verifyAppId;
  private TCaptchaVerifyListener captchaVerifyListener = new TCaptchaVerifyListener() {
    @Override
    public void onVerifyCallback(JSONObject jsonObject) {
      try {
        WritableMap data = Arguments.createMap();
        int ret = jsonObject.getInt("ret");
        data.putInt("ret", ret);
        data.putString("appid", jsonObject.getString("appid"));
        data.putString("ticket", jsonObject.getString("ticket"));
        data.putString("randstr", jsonObject.getString("randstr"));
        verifyPromise.resolve(data);
      } catch (Exception e) {
        verifyPromise.reject("500", "Verify error", e);
      }
    }
  };

  public RNUelongTencentCaptchaModule(ReactApplicationContext reactContext) {
    super(reactContext);
    this.reactContext = reactContext;
  }

  @Override
  public String getName() {
    return "RNUelongTencentCaptcha";
  }

  @ReactMethod
  public void showCaptcha(String appId, Promise promise) {
    verifyAppId = appId;
    verifyPromise = promise;
    // fixbug: Calling View methods on another thread than the UI thread
    getCurrentActivity().runOnUiThread(new Runnable() {
      @Override
      public void run() {
        try {
          //    toastMsg("showCaptcha start...");
          if (dialog != null) {
            dialog.dismiss();
          }

          dialog = new TCaptchaDialog(getCurrentActivity(), verifyAppId, captchaVerifyListener, "ssss");
          dialog.show();
        } catch (Exception e) {
          verifyPromise.reject("500", "Verify error", e);
          // e.printStackTrace();
        }
      }
    });
  }
}